﻿/*
 * BUT.h
 *
 * Created: 14.01.2023 19:39:45
 *  Author: Валера
 */ 


#ifndef BUT_AVR_H_
#define BUT_AVR_H_
#include <avr/io.h>
	#ifndef U8U16
	#define U8U16
		typedef uint8_t		u8;
		typedef uint16_t	u16;
	#endif
#define _pull_up_	1	//Включение подтяжки выхода
#define _Float_		0	//Плавающий выход
	


	class	But_avr{
		private:
			 volatile u8	*	pin_port;//адрес регистра порта
			 u8		num_pin;		//номер порта
			 bool	state_pin;		//состояние порта
			 bool	bef_state_pin;	//предыдущее состояние порта
			 bool	MPF;			//меркер положительного фронта
			 bool	MNF;			//меркер отрицательного фронта
			 u16	cycl_del;		//количество циклов задержки (заданное)
			 u16	del;			//счетчик циклов задержки (реальное)
			 bool	bef_check;		//состояние порта в предыдущем цикле
		
		public:
		//конструктор........................
			But_avr(volatile u8 *reg_pin, volatile u8 pin, volatile u16 cycl, u8 mode){
				cycl_del = cycl;				//установка лимита циклов
				pin_port = reg_pin;				//запись указателя на регистр порта
				num_pin  = pin;					//установка номера порта
				bef_state_pin = true;			//предыдущее состояние порта
				state_pin = true;				//состояние вывода порта
				if(mode)
					*(pin_port+2) |= 1<<num_pin;//инициализация подтяжки порта
			}
			
		//проверка состояния кнопки..................	
			volatile void check_but(){				
				if((*pin_port) & (1<<num_pin)){
					if(del < cycl_del){
						state_pin = false;
						del++;
					}else{
						state_pin = true;
					}
					
				}else{
					del = 0;
					state_pin = false;
				}
			
			}			

		//Проверка всех фронтов кнопки................................
			void FPN_check(){
				check_but();
				if(!state_pin && bef_state_pin) //FN негативный фронт
					MNF = true;
				else
					MNF = false;
					
				if(state_pin && !bef_state_pin) //FP позитивный фронт
					MPF = true;
				else
					MPF = false;
					
				bef_state_pin = state_pin;
				
			}




		//getters & setters......................................
			//возврат маркера отрицательного фронта
			bool get_MNF(){ 
				return MNF;
			}
			//возврат маркера положительного фронта
			bool get_MPF(){
				return MPF;
			}
			//возврат состояния кнопки (низкий/высокий уровень)
			bool get_state_pin(){
				return state_pin;
			}







	
			
		
	};

//=========================================================================














#endif /* BUT_H_ */

