﻿/*
 * my_fun.c
 *
 * Created: 28.10.2021 16:42:50
 *  Author: Валера
 */ 
#include <avr/io.h>
#include <stdbool.h>

#ifndef U8U16
#define U8U16
	typedef uint8_t		u8;
	typedef uint16_t	u16;
#endif

#ifndef LOGIC_H
#define LOGIC_H
//класс проверки фронтов и состояния порта..............................
class front_port{

	public:
		front_port(volatile u8 *port, u8 pin){
			this->port = port;
			this->pin = pin;
		}
		//	Выделение положительного фронта вывода порта............................................
		//	port - имя порта; pin - номер порта; bef - меркер предыдущего состояния порта  
		bool FP_port(void){
			if(((*port) & 1<<pin)&&(!bef1)){
				bef1 = 1;
				return 1;
			}else{
				if((*port) & 1<<pin) 
					bef1 = 1;
				else 
					bef1 = 0;
				return 0;
			}
	};




	private:
		bool bef1;
		volatile u8 * port;
		u8 pin;
	
};
//класс проверки фронтов маркеров=======================================
class front_m{
	public:
		//проверка положительного и отрицательного фронта....................
		bool check_MPNF(){
			//положительный фронт..............
			if(M && !bef){
				bef = M;
				mpf = true;
			}else{
				bef = M;
				mpf = false;
			}
		
		//проверка отрицательного фронта.......................
		
			if(!M && bef){
				bef = M;
				mnf = true;
			}else{
				bef = M;
				mnf = false;
			}
		}
		//установка и сброс маркера.................................
		void set_M(void){
			M = true;
		}
		void res_M(void){
			M = false;
		}
		//считывание маркеров фронта...................................
		bool get_MPF(void){	//положительный
			return mpf;
		}
		bool get_MNF(void){ //отрицательный
			return mnf;
		}
		//считывание состояния маркера.......................
		bool get_state(){
			return M;
		}
	
	
	private:
		bool mpf;	//маркер положительного фронта маркера М
		bool mnf;	//маркер отрицательного фронта маркера М
		bool M, bef;//маркер и его предыдущее состояние 
		
	
};




#endif






